image: quay.io/buildah/stable:latest

stages:
  - build
  - deploy

variables:
  REGISTRY_LOGIN: buildah login -u gitlab-ci-token -p $CI_REGISTRY_PASSWORD
  REGISTRY_LOGOUT: buildah logout
  IMAGE_BUILD: buildah build-using-dockerfile --storage-driver vfs --format docker
  IMAGE_PUSH: buildah push --storage-driver vfs
  DOCKERFILE: Dockerfile
  IMAGE_NAME: $CI_REGISTRY_IMAGE/resif-routing
  IMAGE_NAME_COMMIT: $IMAGE_NAME:$CI_COMMIT_SHORT_SHA
  IMAGE_NAME_BRANCH: $IMAGE_NAME:$CI_COMMIT_BRANCH

build:
  before_script:
    - $REGISTRY_LOGIN $CI_REGISTRY
  after_script:
    - $REGISTRY_LOGOUT $CI_REGISTRY
  stage: build
  only:
    - develop
    - master
  script:
    - $IMAGE_BUILD --file $DOCKERFILE --tag $IMAGE_NAME_COMMIT .
    - $IMAGE_PUSH  $IMAGE_NAME_COMMIT $IMAGE_NAME_COMMIT
    - $IMAGE_PUSH  $IMAGE_NAME_COMMIT $IMAGE_NAME_BRANCH

deploy_k8s-staging:
  image:
    name: bitnami/kubectl:1.24
    entrypoint: ['']
  stage: deploy
  variables:
  script:
    - kubectl --kubeconfig=$AUTO_DEPLOY_K8S_STAGING rollout restart deployment/staging-resif-routing
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

deploy_k8s-prod:
  image:
    name: bitnami/kubectl:1.24
    entrypoint: ['']
  stage: deploy
  variables:
  script:
    - kubectl --kubeconfig=$AUTO_DEPLOY_K8S_PRODUCTION rollout restart deployment/production-resif-routing-deployment
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
